760e2222e53232b50d43f03c2638aef20b124c5e
[lttng-tools.git] / tests / stress / test_multi_sessions_per_uid_5app_streaming
1 #!/bin/bash
2 #
3 # Copyright (C) - 2013 David Goulet <dgoulet@efficios.com>
4 #
5 # This library is free software; you can redistribute it and/or modify it under
6 # the terms of the GNU Lesser General Public License as published by the Free
7 # Software Foundation; version 2.1 of the License. details.
8 #
9 # You should have received a copy of the GNU Lesser General Public License
10 # along with this library; if not, write to the Free Software Foundation, Inc.,
11 # 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
12
13 CURDIR=$(dirname $0)/
14 TESTDIR=$CURDIR/..
15 LAUNCH_APP="launch_ust_app"
16 SESSION_NAME="stress"
17 EVENT_NAME="tp:tptest"
18 LOG_FILE_SESSIOND="sessiond.log"
19 LOG_FILE_RELAYD="relayd.log"
20 CHANNEL_NAME="channel0"
21 NR_APP=5
22 NR_SESSION=5
23 NR_LOOP=1000
24 COREDUMP_FILE=$(cat /proc/sys/kernel/core_pattern)
25 NUM_TESTS=16
26 APPS_PID=
27
28 TEST_DESC="Stress test - $NR_SESSION sessions per UID streaming with $NR_APP apps"
29
30 source $TESTDIR/utils/utils.sh
31
32 # MUST set TESTDIR before calling those functions
33
34 function enable_channel_per_uid()
35 {
36 local sess_name=$1
37 local channel_name=$2
38
39 $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-channel --buffers-uid -u $channel_name -s $sess_name >/dev/null 2>&1
40 ok $? "Enable channel $channel_name per UID for session $sess_name"
41 }
42
43 function lttng_create_session_uri
44 {
45 local name=$1
46
47 # Create session with default path
48 $TESTDIR/../src/bin/lttng/$LTTNG_BIN create $name -U net://localhost >/dev/null 2>&1
49 ok $? "Create session on net://localhost"
50 }
51
52 function check_sessiond()
53 {
54 if [ -z "$(pidof lt-lttng-sessiond)" ]; then
55 local str_date=$(date +%H%M%S-%d%m%Y)
56
57 diag "!!!The session daemon died unexpectedly!!!"
58 mv $LOG_FILE_SESSIOND $LOG_FILE_SESSIOND-$str_date
59 if [ -e $COREDUMP_FILE ]; then
60 mv $COREDUMP_FILE $COREDUMP_FILE-$str_date
61 fi
62 exit 1
63 fi
64 }
65
66 function check_relayd()
67 {
68 if [ -z "$(pidof lt-lttng-relayd)" ]; then
69 local str_date=$(date +%H%M%S-%d%m%Y)
70
71 diag "!!!The relay daemon died unexpectedly!!!"
72 mv $LOG_FILE_RELAYD $LOG_FILE_RELAYD-$str_date
73 if [ -e $COREDUMP_FILE ]; then
74 mv $COREDUMP_FILE $COREDUMP_FILE-$str_date
75 fi
76 exit 1
77 fi
78 }
79
80 function start_sessiond()
81 {
82 local SESSIOND_BIN="lttng-sessiond"
83
84 validate_kernel_version
85 if [ $? -ne 0 ]; then
86 fail "Start session daemon"
87 BAIL_OUT "*** Kernel too old for session daemon tests ***"
88 fi
89
90 if [ -z $(pidof lt-$SESSIOND_BIN) ]; then
91 # We have to start it like this so the ulimit -c is used by this
92 # process. Also, we collect any error message printed out.
93 $TESTDIR/../src/bin/lttng-sessiond/$SESSIOND_BIN --quiet --background --consumerd32-path="$TESTDIR/../src/bin/lttng-consumerd/lttng-consumerd" --consumerd64-path="$TESTDIR/../src/bin/lttng-consumerd/lttng-consumerd" >$LOG_FILE_SESSIOND 2>&1
94 status=$?
95 ok $status "Start session daemon"
96 fi
97 }
98
99 function start_relayd
100 {
101 local opt=$1
102 local RELAYD_BIN="lttng-relayd"
103
104 if [ -z $(pidof lt-$RELAYD_BIN) ]; then
105 $TESTDIR/../src/bin/lttng-relayd/$RELAYD_BIN $opt >$LOG_FILE_RELAYD 2>&1 &
106 ok $? "Start lttng-relayd (opt: \"$opt\")"
107 fi
108 }
109
110 test_stress()
111 {
112 for b in $(seq 1 $NR_LOOP); do
113 for a in $(seq 1 $NR_SESSION); do
114 lttng_create_session_uri $SESSION_NAME-$a
115 check_sessiond
116 check_relayd
117 enable_channel_per_uid $SESSION_NAME-$a $CHANNEL_NAME
118 check_sessiond
119 check_relayd
120 enable_ust_lttng_event_ok $SESSION_NAME-$a $EVENT_NAME
121 check_sessiond
122 check_relayd
123 start_lttng_tracing_ok $SESSION_NAME-$a
124 check_sessiond
125 check_relayd
126 done
127
128 for a in $(seq 1 $NR_SESSION); do
129 stop_lttng_tracing_ok $SESSION_NAME-$a
130 check_sessiond
131 check_relayd
132 destroy_lttng_session_ok $SESSION_NAME-$a
133 check_sessiond
134 check_relayd
135 done
136 done
137
138 return 0
139 }
140
141 function cleanup()
142 {
143 diag "Cleaning up!"
144 for p in ${APPS_PID}; do
145 kill -s SIGKILL ${p}
146 wait ${p} 2>/dev/null
147 done
148 APPS_PID=
149 stop_lttng_sessiond
150 stop_lttng_relayd
151 }
152
153 function sighandler()
154 {
155 cleanup
156 rm $LOG_FILE_SESSIOND $LOG_FILE_RELAYD
157 exit 1
158 }
159
160 trap sighandler SIGINT
161 trap sighandler SIGTERM
162
163 # Make sure we collect a coredump if possible.
164 ulimit -c unlimited
165
166 # MUST set TESTDIR before calling those functions
167 plan_tests $NUM_TESTS
168
169 print_test_banner "$TEST_DESC"
170
171 TRACE_PATH=$(mktemp -d)
172
173 start_relayd "-o $TRACE_PATH"
174 start_sessiond
175
176 diag "Starting applications launcher"
177
178 # Start NR_APP applications script that will spawn apps non stop.
179 ./$TESTDIR/stress/$LAUNCH_APP $NR_APP &
180 APPS_PID="${APPS_PID} ${!}"
181
182 test_stress
183 out=$?
184 if [ $out -ne 0 ]; then
185 cleanup
186 exit $out
187 fi
188
189 cleanup
190 rm -rf $TRACE_PATH
191 rm $LOG_FILE_SESSIOND $LOG_FILE_RELAYD
192 exit 0
This page took 0.034265 seconds and 4 git commands to generate.